package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class AnaliseRestricoesContratuaisPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");

    By telaAnaliseRestricoesContratuais = By.xpath("//span[text() = 'Planejamento » Cardápio » Relatórios']");
    By campoTipo = By.xpath("//div[@class=\"field-group-rows\"]/div[2]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By tipoContrato = By.xpath("//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid open\"]//li[text() = 'Contrato']");
    By tipoPlanejado = By.xpath("//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid open\"]//li[text() = 'Planejado']");

    By campoRelatorio = By.xpath("//div[@data-zh-id='4189642811487723761863']//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioGrupoPratoAnaliticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Grupo de Pratos Analítico (Mês)']");
    By relatorioGrupoPratoSinteticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Grupo de Pratos Sintético (Mês)']");
    By relatorioGrupoPratoAnaliticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Grupo de Pratos Analítico (Semana)']");
    By relatorioGrupoPratoSinteticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Grupo de Pratos Sintético (Semana)']");
    By relatorioLimiteServicoAnalitico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Limite Per Capita por Serviço Analítico']");
    By relatorioLimiteServicoSintetico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Limite Per Capita por Serviço Sintético']");
    By relatorioProdutoGrupoPratoAnaliticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Produtos por Grupo de Prato Analítico (Mês)']");
    By relatorioProdutoGrupoPratoSinteticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Produtos por Grupo de Prato Sintético (Mês)']");
    By relatorioProdutoGrupoPratoAnaliticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Produtos por Grupo de Prato Analítico (Semana)']");
    By relatorioProdutoGrupoPratoSinteticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Produtos por Grupo de Prato Sintético (Semana)']");
    By relatorioPratoAnaliticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Pratos Analítico (Mês)']");
    By relatorioPratoSinteticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Pratos Sintético (Mês)']");
    By relatorioPratoAnaliticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Pratos Analítico (Semana)']");
    By relatorioPratoSinteticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Pratos Sintético (Semana)']");
    By relatorioOpcoesGrupoPratoAnaliticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Opções por Grupo de Prato Analítico (Mês)']");
    By relatorioOpcoesGrupoPratoSinteticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Opções por Grupo de Prato Sintético (Mês)']");
    By relatorioOpcoesGrupoPratoAnaliticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Opções por Grupo de Prato Analítico (Semana)']");
    By relatorioRestricoesGrupoAnalitico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Restrições de Produtos por Grupo de Prato Analítico']");
    By relatorioRestricoesGrupoSintetico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Restrições de Produtos por Grupo de Prato Sintético']");

    By campoAgrupamentoUnidade = By.id("NMGRUPFILI");
    By agrupamentoMateriaPrima = By.xpath("//div[@data-zh-id=\"4189642824053476841867\"]//span[text() = '0000000002 | MATERIA PRIMA - MATERIAL DE EMBALAGEM']");

    By campoAgrupamentoPrato = By.id("NMAGRUPGRPRAT");
    By agrupamentoPratoSolicitados = By.xpath("//div[@data-zh-field-name=\"NMAGRUPGRPRAT\"]//span[text() = 'SOLICITADOS']");
    By agrupamentoPratoEntregues = By.xpath("//div[@data-zh-field-name=\"NMAGRUPGRPRAT\"]//span[text() = 'ENTREGUES']");

    By campoGrupoPrato = By.id("NMGRUPOPRATO");
    By grupoPratoJantar = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTAR']");

    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO JABAQUARA']");
    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO BC 129']");

    By campoGrupoServico = By.id("NMGRUPSERV");
    By grupoGeral = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'GERAL']");

    By campoServico = By.id("NMSERVICO");
    By servicoRetiradas = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'RETIRADAS']");
    By servicoJantar = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTAR']");

    By botaoOk = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']//span[text() = 'Ok']");

    By campoProdutoInicial = By.id("NMPRODINI");
    By produtoInicial = By.xpath("//div[@data-zh-id='4189642825413897711894']//span[text() = '0 | REFEIÇÕES TRANSPORTADAS']");
    By botaoPesquisarProdutoFinal = By.xpath("//div[@id='NMPRODFIN']//span[@style=\"background-image: none; display: block;\"]");
    By campoProcurarProdutoFinal = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By campoProdutoFinal = By.id("NMPRODFIN");
    By produtoFinal = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'COLA DE CONTATO']");

    By campoMes = By.id("MES");
    By mesMaio = By.xpath("//div[@class=\"calendar\"]//div[text() = 'Mai']");
    By botaoCampoMes = By.xpath("//div[@id=\"MES\"]//span[@style=\"background-image: none; display: block;\"]");
    By ordenacaoAlfabetica = By.xpath("//label[@for='radio-IDORDENAGR-A']//div[@class='zh-inner-circle']");

    By checkExbibeProdutoDivergentes = By.xpath("//label[@for=\"zh-checkbox-IDPRODDIVERG\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By inputCheckProdutosDivergentes = By.id("zh-checkbox-IDPRODDIVERG");

    By mensagemObrigatorioTipo = By.xpath("//div[@data-zh-id=\"4189642842848341994\"]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"418964286711471151871\"]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"4189642815591461781879\"]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioMes = By.xpath("//div[@data-zh-id=\"418964287940067671893\"]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioProdutoInicial = By.xpath("//div[@data-zh-id=\"4189642825413897711894\"]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioProdutoFinal = By.xpath("//div[@data-zh-id=\"4189642837021019851897\"]//span[@class=\"zh-validation-error\"]");

    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@class='zh-inner-circle']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        tempo();
        click(botaoMenu);
        sendKeys(campoPesquisar, "Análise de Restrições Contratuais");
        click(telaAnaliseRestricoesContratuais);
    }

    public void selecionarRelatorio(String nomeDoRelatorio) {
        tempo();
        if (nomeDoRelatorio == "Frequência de Grupo de Pratos Analítico (Mês)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoPratoAnaliticoMes);
        } else if (nomeDoRelatorio == "Frequência de Grupo de Pratos Sintético (Mês)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoPratoSinteticoMes);
        } else if (nomeDoRelatorio == "Frequência de Grupo de Pratos Analítico (Semana)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoPratoAnaliticoSemana);
        } else if (nomeDoRelatorio == "Frequência de Grupo de Pratos Sintético (Semana)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoPratoSinteticoSemana);
        } else if (nomeDoRelatorio == "Limite Per Capita por Serviço Analítico") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioLimiteServicoAnalitico);
        } else if (nomeDoRelatorio == "Limite Per Capita por Serviço Sintético") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioLimiteServicoSintetico);
        } else if (nomeDoRelatorio == "Frequência de Produtos por Grupo de Prato Analítico (Mês)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioProdutoGrupoPratoAnaliticoMes);
        } else if (nomeDoRelatorio == "Frequência de Produtos por Grupo de Prato Sintético (Mês)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioProdutoGrupoPratoSinteticoMes);
        } else if (nomeDoRelatorio == "Frequência de Produtos por Grupo de Prato Analítico (Semana)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioProdutoGrupoPratoAnaliticoSemana);
        } else if (nomeDoRelatorio == "Frequência de Produtos por Grupo de Prato Sintético (Semana)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioProdutoGrupoPratoSinteticoSemana);
        } else if (nomeDoRelatorio == "Frequência de Pratos Analítico (Mês)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioPratoAnaliticoMes);
        } else if (nomeDoRelatorio == "Frequência de Pratos Sintético (Mês)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioPratoSinteticoMes);
        } else if (nomeDoRelatorio == "Frequência de Pratos Analítico (Semana)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioPratoAnaliticoSemana);
        } else if (nomeDoRelatorio == "Frequência de Pratos Sintético (Semana)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioPratoSinteticoSemana);
        } else if (nomeDoRelatorio == "Frequência de Opções por Grupo de Prato Analítico (Mês)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioOpcoesGrupoPratoAnaliticoMes);
        } else if (nomeDoRelatorio == "Frequência de Opções por Grupo de Prato Sintético (Mês)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioOpcoesGrupoPratoSinteticoMes);
        } else if (nomeDoRelatorio == "Frequência de Opções por Grupo de Prato Analítico (Semana)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioOpcoesGrupoPratoAnaliticoSemana);
        } else if (nomeDoRelatorio == "Restrições de Produtos por Grupo de Prato Analítico") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioRestricoesGrupoAnalitico);
        } else if (nomeDoRelatorio == "Restrições de Produtos por Grupo de Prato Sintético") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioRestricoesGrupoSintetico);
        }
    }

    public void selecionarProdutos() {
        tempo();
        clicarCampoSelecionarValor(campoProdutoInicial, produtoInicial);
        click(botaoPesquisarProdutoFinal);
        sendKeys(campoProcurarProdutoFinal, "707");
        click(produtoFinal);
    }

    public void selecionarTipo(String tipo) {
        if (tipo == "Contrato") {
            clicarCampoSelecionarValor(campoTipo, tipoContrato);
        } else if (tipo == "Planejado") {
            clicarCampoSelecionarValor(campoTipo, tipoPlanejado);
        }
    }

    public void selecionarAgrupamentoUnidade() {
        click(campoAgrupamentoUnidade);
        click(agrupamentoMateriaPrima);
    }

    public void selecionarUnidades() {
        click(campoUnidade);
        click(unidadeDepositoJabaquara);
        click(unidadeDepositoBc129);
        click(botaoOk);
    }

    public void selecionarGrupoGeral() {
        tempo();
        click(campoGrupoServico);
        click(grupoGeral);
        click(botaoOk);
    }

    public void selecionarServicos() {
        tempo();
        click(campoServico);
        click(servicoJantar);
        click(servicoRetiradas);
        click(botaoOk);
    }

    public void selecionarAgrupamentoPrato() {
        click(campoAgrupamentoPrato);
        click(agrupamentoPratoSolicitados);
        click(botaoOk);
    }

    public void selecionarGrupoPrato() {
        click(campoGrupoPrato);
        click(grupoPratoJantar);
        click(botaoOk);
    }

    public void selecionarMesMaio() {
        click(campoMes);
        click(mesMaio);
    }

    public void selecionarOrdencaoAlfabetica() {
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 200)");
        click(ordenacaoAlfabetica);
    }

    public void verificaProdutosDivergentes() {
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 200)");
        boolean produtosDivergentes = returnIfElementIsSelected(inputCheckProdutosDivergentes);
        Assert.assertEquals(produtosDivergentes, false, "Verificação se o check-box de 'Exibe apenas Produtos Divergentes', por padrão vem desmarcado");
        click(checkExbibeProdutoDivergentes);
        produtosDivergentes = returnIfElementIsSelected(inputCheckProdutosDivergentes);
        Assert.assertEquals(produtosDivergentes, true, "Verificação se após clicar no check-box de 'Exibe apenas Produtos Divergentes', o mesma fica selecionado");
    }

    public void geraRelatorio() {
        tempo();
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    public void verficarCamposObrigatorios(String nomeRelatorio) {
        tempo();
        click(botaoCampoMes);
        click(botaoRelatorio);
        String mensagemEsperada = "Campo obrigatório";

        if (nomeRelatorio.equals("Limite Per Capita por Serviço Analítico") || nomeRelatorio.equals("Limite Per Capita por Serviço Sintético")
                || nomeRelatorio.equals("Frequência de Produtos por Grupo de Prato Analítico (Mês)") || nomeRelatorio.equals("Frequência de Produtos por Grupo de Prato Sintético (Mês)")
                || nomeRelatorio.equals("Frequência de Produtos por Grupo de Prato Analítico (Semana)") || nomeRelatorio.equals("Frequência de Produtos por Grupo de Prato Sintético (Semana)")
                || nomeRelatorio.equals("Restrições de Produtos por Grupo de Prato Analítico") || nomeRelatorio.equals("Restrições de Produtos por Grupo de Prato Sintético")) {

            String produtoInicial = getText(mensagemObrigatorioProdutoInicial);
            String produtoFinal = getText(mensagemObrigatorioProdutoFinal);
            Assert.assertEquals(produtoInicial, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo produto inicial");
            Assert.assertEquals(produtoFinal, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo produto final");
        }

        //valores encontrados
        String tipo = getText(mensagemObrigatorioTipo);
        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String mes = getText(mensagemObrigatorioMes);

        Assert.assertEquals(tipo, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo tipo");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo unidade");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo servico");
        Assert.assertEquals(mes, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo mês");
    }

    public void deixarCampoUnidadeVazio() {
        click(campoUnidade);
        click(unidadeDepositoBc129);
        click(botaoOk);
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

}
