package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.AcompanhamentoPUFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.pages.AcompanhamentoPUPage;
import org.testng.annotations.Test;

public class AcompanhamentoPUTests extends TestBase {

    AcompanhamentoPUPage acompanhamentoPUPage;
    AcompanhamentoPUFlows acompanhamentoPUFlows;
    LoginFlows loginFlows;

    //gerar o relatório Acompanhamento de P.U. com a opção 'Todos' serviços selecionada
    //gerar novamente o relatório Acompanhamento de P.U. agora com os serviços selecionados manualmente
    //verificar os campos obrigatórios da tela
    @Test
    public void testeComponentes() {
        acompanhamentoPUPage = new AcompanhamentoPUPage();
        acompanhamentoPUFlows = new AcompanhamentoPUFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        acompanhamentoPUFlows.navegateAcompanhamentoPU();
        acompanhamentoPUPage.selecionarRelatorio();
        acompanhamentoPUPage.selecionarUnidade();
        acompanhamentoPUPage.selecionarMesNovembro();
        acompanhamentoPUPage.selecionarCustos();
        acompanhamentoPUPage.geraRelatorio();
        acompanhamentoPUPage.selecionarServicos();
        acompanhamentoPUPage.geraRelatorio();
        acompanhamentoPUPage.refresh();
        acompanhamentoPUPage.campoObrigatorios();


        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

}
